#include <bits/stdc++.h>
using namespace std;
int n,m,t,a[75005],b[75005],r,x;
int main(){
    cin>>t;
    for(int h=1;h<=t;h++){
        cin>>n>>m;
        for(int i=1;i<=n;i++){
            cin>>a[i];
        }
        for(int i=1;i<=m;i++){
            cin>>b[i];
        }
        sort(a+1,a+1+n);
        x=a[2]-a[1];
        r=1;
        for(int i=1;i<=m;i++){
            if(b[i]-a[1]%x==0)r=0;
        }
        cout<<r<<endl;
    }
    return 0;
}